Index: /NEMO/trunk/src/OCE/SBC/sbcblk.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk.F90	(revision 14071)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk.F90	(revision 14072)
@@ -632,38 +712,50 @@
 
       CASE( np_NCAR      )
-         CALL turb_ncar    ( rn_zqt, rn_zu, ptsk, ztpot, pssq, zqair, wndm,                              &
-            &                zcd_oce, zch_oce, zce_oce, t_zu, q_zu, zU_zu, cdn_oce, chn_oce, cen_oce )
-
+         CALL turb_ncar    (     rn_zqt, rn_zu, ptsk, ptair, pssq, pqair, wndm, &
+            &                zcd_oce, zch_oce, zce_oce, theta_zu, q_zu, zU_zu , &
+            &                nb_iter=nn_iter_algo )
+         !
       CASE( np_COARE_3p0 )
-         CALL turb_coare3p0 ( kt, rn_zqt, rn_zu, ptsk, ztpot, pssq, zqair, wndm, ln_skin_cs, ln_skin_wl, &
-            &                zcd_oce, zch_oce, zce_oce, t_zu, q_zu, zU_zu, cdn_oce, chn_oce, cen_oce,   &
-            &                Qsw=qsr(:,:), rad_lw=pqlw(:,:), slp=pslp(:,:) )
-
+         CALL turb_coare3p0( kt, rn_zqt, rn_zu, ptsk, ptair, pssq, pqair, wndm, &
+            &                ln_skin_cs, ln_skin_wl,                            &
+            &                zcd_oce, zch_oce, zce_oce, theta_zu, q_zu, zU_zu,  &
+            &                nb_iter=nn_iter_algo,                              &
+            &                Qsw=qsr(:,:), rad_lw=pdqlw(:,:), slp=pslp(:,:) )
+         !
       CASE( np_COARE_3p6 )
-         CALL turb_coare3p6 ( kt, rn_zqt, rn_zu, ptsk, ztpot, pssq, zqair, wndm, ln_skin_cs, ln_skin_wl, &
-            &                zcd_oce, zch_oce, zce_oce, t_zu, q_zu, zU_zu, cdn_oce, chn_oce, cen_oce,   &
-            &                Qsw=qsr(:,:), rad_lw=pqlw(:,:), slp=pslp(:,:) )
-
+         CALL turb_coare3p6( kt, rn_zqt, rn_zu, ptsk, ptair, pssq, pqair, wndm, &
+            &                ln_skin_cs, ln_skin_wl,                            &
+            &                zcd_oce, zch_oce, zce_oce, theta_zu, q_zu, zU_zu,  &
+            &                nb_iter=nn_iter_algo,                              &
+            &                Qsw=qsr(:,:), rad_lw=pdqlw(:,:), slp=pslp(:,:) )
+         !
       CASE( np_ECMWF     )
-         CALL turb_ecmwf   ( kt, rn_zqt, rn_zu, ptsk, ztpot, pssq, zqair, wndm, ln_skin_cs, ln_skin_wl,  &
-            &                zcd_oce, zch_oce, zce_oce, t_zu, q_zu, zU_zu, cdn_oce, chn_oce, cen_oce,   &
-            &                Qsw=qsr(:,:), rad_lw=pqlw(:,:), slp=pslp(:,:) )
-
+         CALL turb_ecmwf   ( kt, rn_zqt, rn_zu, ptsk, ptair, pssq, pqair, wndm, &
+            &                ln_skin_cs, ln_skin_wl,                            &
+            &                zcd_oce, zch_oce, zce_oce, theta_zu, q_zu, zU_zu,  &
+            &                nb_iter=nn_iter_algo,                              &
+            &                Qsw=qsr(:,:), rad_lw=pdqlw(:,:), slp=pslp(:,:) )
+         !
+      CASE( np_ANDREAS   )
+         CALL turb_andreas (     rn_zqt, rn_zu, ptsk, ptair, pssq, pqair, wndm, &
+            &                zcd_oce, zch_oce, zce_oce, theta_zu, q_zu, zU_zu , &
+            &                nb_iter=nn_iter_algo   )
+         !
       CASE DEFAULT
-         CALL ctl_stop( 'STOP', 'sbc_oce: non-existing bulk formula selected' )
-
+         CALL ctl_stop( 'STOP', 'sbc_oce: non-existing bulk parameterizaton selected' )
+         !
       END SELECT
-      
+
       IF( iom_use('Cd_oce') )   CALL iom_put("Cd_oce",   zcd_oce * tmask(:,:,1))
       IF( iom_use('Ce_oce') )   CALL iom_put("Ce_oce",   zce_oce * tmask(:,:,1))
       IF( iom_use('Ch_oce') )   CALL iom_put("Ch_oce",   zch_oce * tmask(:,:,1))
       !! LB: mainly here for debugging purpose:
-      IF( iom_use('theta_zt') ) CALL iom_put("theta_zt", (ztpot-rt0) * tmask(:,:,1)) ! potential temperature at z=zt
-      IF( iom_use('q_zt') )     CALL iom_put("q_zt",     zqair       * tmask(:,:,1)) ! specific humidity       "
-      IF( iom_use('theta_zu') ) CALL iom_put("theta_zu", (t_zu -rt0) * tmask(:,:,1)) ! potential temperature at z=zu
+      IF( iom_use('theta_zt') ) CALL iom_put("theta_zt", (ptair-rt0) * tmask(:,:,1)) ! potential temperature at z=zt
+      IF( iom_use('q_zt') )     CALL iom_put("q_zt",     pqair       * tmask(:,:,1)) ! specific humidity       "
+      IF( iom_use('theta_zu') ) CALL iom_put("theta_zu", (theta_zu -rt0) * tmask(:,:,1)) ! potential temperature at z=zu
       IF( iom_use('q_zu') )     CALL iom_put("q_zu",     q_zu        * tmask(:,:,1)) ! specific humidity       "
       IF( iom_use('ssq') )      CALL iom_put("ssq",      pssq        * tmask(:,:,1)) ! saturation specific humidity at z=0
       IF( iom_use('wspd_blk') ) CALL iom_put("wspd_blk", zU_zu       * tmask(:,:,1)) ! bulk wind speed at z=zu
-      
+
       IF( ln_skin_cs .OR. ln_skin_wl ) THEN
          !! ptsk and pssq have been updated!!!
@@ -677,5 +769,5 @@
       END IF
 
-      !  Turbulent fluxes over ocean  => BULK_FORMULA @ sbcblk_phy.F90
+      !  Turbulent fluxes over ocean  => BULK_FORMULA @ sbc_phy.F90
       ! -------------------------------------------------------------
 
@@ -687,32 +779,32 @@
             psen(ji,jj)   = zztmp * zch_oce(ji,jj)
             pevp(ji,jj)   = zztmp * zce_oce(ji,jj)
-            rhoa(ji,jj)   = rho_air( ptair(ji,jj), phumi(ji,jj), pslp(ji,jj) )
+            rhoa(ji,jj)   = rho_air( ptair(ji,jj), pqair(ji,jj), pslp(ji,jj) )
          END_2D
       ELSE                      !==  BLK formulation  ==!   turbulent fluxes computation
-         CALL BULK_FORMULA( rn_zu, ptsk(:,:), pssq(:,:), t_zu(:,:), q_zu(:,:), &
+         CALL BULK_FORMULA( rn_zu, ptsk(:,:), pssq(:,:), theta_zu(:,:), q_zu(:,:), &
             &               zcd_oce(:,:), zch_oce(:,:), zce_oce(:,:),          &
             &               wndm(:,:), zU_zu(:,:), pslp(:,:),                  &
-            &               taum(:,:), psen(:,:), zqla(:,:),                   &
+            &               taum(:,:), psen(:,:), plat(:,:),                   &
             &               pEvap=pevp(:,:), prhoa=rhoa(:,:), pfact_evap=rn_efac )
 
-         zqla(:,:) = zqla(:,:) * tmask(:,:,1)
          psen(:,:) = psen(:,:) * tmask(:,:,1)
+         plat(:,:) = plat(:,:) * tmask(:,:,1)
          taum(:,:) = taum(:,:) * tmask(:,:,1)
          pevp(:,:) = pevp(:,:) * tmask(:,:,1)
 
          DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
-            IF( wndm(ji,jj) > 0._wp ) THEN
-               zztmp = taum(ji,jj) / wndm(ji,jj)
+         IF( wndm(ji,jj) > 0._wp ) THEN
+            zztmp = taum(ji,jj) / wndm(ji,jj)
 #if defined key_cyclone
-               ztau_i(ji,jj) = zztmp * zwnd_i(ji,jj)
-               ztau_j(ji,jj) = zztmp * zwnd_j(ji,jj)
+            ztau_i(ji,jj) = zztmp * zwnd_i(ji,jj)
+            ztau_j(ji,jj) = zztmp * zwnd_j(ji,jj)
 #else
-               ztau_i(ji,jj) = zztmp * pwndi(ji,jj)
-               ztau_j(ji,jj) = zztmp * pwndj(ji,jj)
-#endif
-            ELSE
-               ztau_i(ji,jj) = 0._wp
-               ztau_j(ji,jj) = 0._wp                 
-            ENDIF
+            ztau_i(ji,jj) = zztmp * pwndi(ji,jj)
+            ztau_j(ji,jj) = zztmp * pwndj(ji,jj)
+#endif
+         ELSE
+            ztau_i(ji,jj) = 0._wp
+            ztau_j(ji,jj) = 0._wp
+         ENDIF
          END_2D
 
@@ -743,32 +835,32 @@
          ENDIF
 
-         CALL iom_put( "taum_oce", taum )   ! output wind stress module
+         ! Saving open-ocean wind-stress (module and components) on T-points:
+         CALL iom_put( "taum_oce",   taum(:,:)*tmask(:,:,1) )   ! output wind stress module
+         !#LB: These 2 lines below mostly here for 'STATION_ASF' test-case, otherwize "utau" (U-grid) and vtau" (V-grid) does the job in: [DYN/dynatf.F90])
+         CALL iom_put( "utau_oce", ztau_i(:,:)*tmask(:,:,1) )  ! utau at T-points!
+         CALL iom_put( "vtau_oce", ztau_j(:,:)*tmask(:,:,1) )  ! vtau at T-points!
 
          IF(sn_cfctl%l_prtctl) THEN
-            CALL prt_ctl( tab2d_1=wndm  , clinfo1=' blk_oce_1: wndm   : ')
-            CALL prt_ctl( tab2d_1=utau  , clinfo1=' blk_oce_1: utau   : ', mask1=umask,   &
-               &          tab2d_2=vtau  , clinfo2='            vtau   : ', mask2=vmask )
+            CALL prt_ctl( tab2d_1=pssq   , clinfo1=' blk_oce_1: pssq   : ')
+            CALL prt_ctl( tab2d_1=wndm   , clinfo1=' blk_oce_1: wndm   : ')
+            CALL prt_ctl( tab2d_1=utau   , clinfo1=' blk_oce_1: utau   : ', mask1=umask,   &
+               &          tab2d_2=vtau   , clinfo2='            vtau   : ', mask2=vmask )
+            CALL prt_ctl( tab2d_1=zcd_oce, clinfo1=' blk_oce_1: Cd     : ')
          ENDIF
          !
       ENDIF !IF( ln_abl )
-      
+
       ptsk(:,:) = ( ptsk(:,:) - rt0 ) * tmask(:,:,1)  ! Back to Celsius
-            
+
       IF( ln_skin_cs .OR. ln_skin_wl ) THEN
          CALL iom_put( "t_skin" ,  ptsk        )  ! T_skin in Celsius
          CALL iom_put( "dt_skin" , ptsk - pst  )  ! T_skin - SST temperature difference...
       ENDIF
-
-      IF(sn_cfctl%l_prtctl) THEN
-         CALL prt_ctl( tab2d_1=pevp  , clinfo1=' blk_oce_1: pevp   : ' )
-         CALL prt_ctl( tab2d_1=psen  , clinfo1=' blk_oce_1: psen   : ' )
-         CALL prt_ctl( tab2d_1=pssq  , clinfo1=' blk_oce_1: pssq   : ' )
-      ENDIF
       !
    END SUBROUTINE blk_oce_1
 
 
-   SUBROUTINE blk_oce_2( ptair, pqsr, pqlw, pprec,   &   ! <<= in
-      &                  psnow, ptsk, psen, pevp     )   ! <<= in
+   SUBROUTINE blk_oce_2( ptair, pdqlw, pprec, psnow, &   ! <<= in
+      &                   ptsk, psen, plat, pevp     )   ! <<= in
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE blk_oce_2  ***
@@ -786,46 +878,26 @@
       !!              - emp     : evaporation minus precipitation       (kg/m2/s)
       !!---------------------------------------------------------------------
-      REAL(wp), INTENT(in), DIMENSION(:,:) ::   ptair
-      REAL(wp), INTENT(in), DIMENSION(:,:) ::   pqsr
-      REAL(wp), INTENT(in), DIMENSION(:,:) ::   pqlw
+      REAL(wp), INTENT(in), DIMENSION(:,:) ::   ptair   ! potential temperature of air #LB: confirm!
+      REAL(wp), INTENT(in), DIMENSION(:,:) ::   pdqlw   ! downwelling longwave radiation at surface [W/m^2]
       REAL(wp), INTENT(in), DIMENSION(:,:) ::   pprec
       REAL(wp), INTENT(in), DIMENSION(:,:) ::   psnow
       REAL(wp), INTENT(in), DIMENSION(:,:) ::   ptsk   ! SKIN surface temperature   [Celsius]
       REAL(wp), INTENT(in), DIMENSION(:,:) ::   psen
+      REAL(wp), INTENT(in), DIMENSION(:,:) ::   plat
       REAL(wp), INTENT(in), DIMENSION(:,:) ::   pevp
       !
       INTEGER  ::   ji, jj               ! dummy loop indices
       REAL(wp) ::   zztmp,zz1,zz2,zz3    ! local variable
-      REAL(wp), DIMENSION(jpi,jpj) ::   ztskk             ! skin temp. in Kelvin 
-      REAL(wp), DIMENSION(jpi,jpj) ::   zqlw              ! long wave and sensible heat fluxes      
-      REAL(wp), DIMENSION(jpi,jpj) ::   zqla              ! latent heat fluxes and evaporation
+      REAL(wp), DIMENSION(jpi,jpj) ::   zqlw              ! net long wave radiative heat flux
       !!---------------------------------------------------------------------
       !
       ! local scalars ( place there for vector optimisation purposes)
 
-
-      ztskk(:,:) = ptsk(:,:) + rt0  ! => ptsk in Kelvin rather than Celsius
-      
       ! ----------------------------------------------------------------------------- !
       !     III    Net longwave radiative FLUX                                        !
       ! ----------------------------------------------------------------------------- !
-
-      !! LB: now moved after Turbulent fluxes because must use the skin temperature rather that the SST
-      !! (ztskk is skin temperature if ln_skin_cs==.TRUE. .OR. ln_skin_wl==.TRUE.)
-      zqlw(:,:) = emiss_w * ( pqlw(:,:) - stefan*ztskk(:,:)*ztskk(:,:)*ztskk(:,:)*ztskk(:,:) ) * tmask(:,:,1)   ! Net radiative longwave flux
-
-      !  Latent flux over ocean
-      ! -----------------------
-
-      ! use scalar version of L_vap() for AGRIF compatibility
-      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
-         zqla(ji,jj) = - L_vap( ztskk(ji,jj) ) * pevp(ji,jj)    ! Latent Heat flux !!GS: possibility to add a global qla to avoid recomputation after abl update
-      END_2D
-
-      IF(sn_cfctl%l_prtctl) THEN
-         CALL prt_ctl( tab2d_1=zqla  , clinfo1=' blk_oce_2: zqla   : ' )
-         CALL prt_ctl( tab2d_1=zqlw  , clinfo1=' blk_oce_2: zqlw   : ', tab2d_2=qsr, clinfo2=' qsr : ' )
-
-      ENDIF
+      !! #LB: now moved after Turbulent fluxes because must use the skin temperature rather than bulk SST
+      !! (ptsk is skin temperature if ln_skin_cs==.TRUE. .OR. ln_skin_wl==.TRUE.)
+      zqlw(:,:) = qlw_net( pdqlw(:,:), ptsk(:,:)+rt0 )
 
       ! ----------------------------------------------------------------------------- !
@@ -836,5 +908,5 @@
          &         - pprec(:,:) * rn_pfac  ) * tmask(:,:,1)
       !
-      qns(:,:) = zqlw(:,:) + psen(:,:) + zqla(:,:)                   &   ! Downward Non Solar
+      qns(:,:) = zqlw(:,:) + psen(:,:) + plat(:,:)                   &   ! Downward Non Solar
          &     - psnow(:,:) * rn_pfac * rLfus                        &   ! remove latent melting heat for solid precip
          &     - pevp(:,:) * ptsk(:,:) * rcp                         &   ! remove evap heat content at SST
@@ -846,5 +918,5 @@
       !
 #if defined key_si3
-      qns_oce(:,:) = zqlw(:,:) + psen(:,:) + zqla(:,:)                             ! non solar without emp (only needed by SI3)
+      qns_oce(:,:) = zqlw(:,:) + psen(:,:) + plat(:,:)                             ! non solar without emp (only needed by SI3)
       qsr_oce(:,:) = qsr(:,:)
 #endif
@@ -854,5 +926,5 @@
       CALL iom_put( "qlw_oce"  , zqlw )                    ! output downward longwave heat over the ocean
       CALL iom_put( "qsb_oce"  , psen )                    ! output downward sensible heat over the ocean
-      CALL iom_put( "qla_oce"  , zqla )                    ! output downward latent   heat over the ocean
+      CALL iom_put( "qla_oce"  , plat )                    ! output downward latent   heat over the ocean
       tprecip(:,:) = pprec(:,:) * rn_pfac * tmask(:,:,1)   ! output total precipitation [kg/m2/s]
       sprecip(:,:) = psnow(:,:) * rn_pfac * tmask(:,:,1)   ! output solid precipitation [kg/m2/s]
@@ -861,5 +933,5 @@
       !
       IF ( nn_ice == 0 ) THEN
-         CALL iom_put( "qemp_oce" , qns-zqlw-psen-zqla )   ! output downward heat content of E-P over the ocean
+         CALL iom_put( "qemp_oce" , qns-zqlw-psen-plat )   ! output downward heat content of E-P over the ocean
          CALL iom_put( "qns_oce"  ,   qns  )               ! output downward non solar heat over the ocean
          CALL iom_put( "qsr_oce"  ,   qsr  )               ! output downward solar heat over the ocean
@@ -869,5 +941,7 @@
       IF(sn_cfctl%l_prtctl) THEN
          CALL prt_ctl(tab2d_1=zqlw , clinfo1=' blk_oce_2: zqlw  : ')
-         CALL prt_ctl(tab2d_1=zqla , clinfo1=' blk_oce_2: zqla  : ', tab2d_2=qsr  , clinfo2=' qsr   : ')
+         CALL prt_ctl(tab2d_1=psen , clinfo1=' blk_oce_2: psen  : ' )
+         CALL prt_ctl(tab2d_1=plat , clinfo1=' blk_oce_2: plat  : ' )
+         CALL prt_ctl(tab2d_1=qns  , clinfo1=' blk_oce_2: qns   : ' )
          CALL prt_ctl(tab2d_1=emp  , clinfo1=' blk_oce_2: emp   : ')
       ENDIF
@@ -883,9 +957,7 @@
    !!   blk_ice_2   : provide the heat and mass fluxes at air-ice interface
    !!   blk_ice_qcn : provide ice surface temperature and snow/ice conduction flux (emulating conduction flux)
-   !!   Cdn10_Lupkes2012 : Lupkes et al. (2012) air-ice drag
-   !!   Cdn10_Lupkes2015 : Lupkes et al. (2015) air-ice drag
    !!----------------------------------------------------------------------
 
-   SUBROUTINE blk_ice_1( pwndi, pwndj, ptair, phumi, pslp , puice, pvice, ptsui,  &   ! inputs
+   SUBROUTINE blk_ice_1( pwndi, pwndj, ptair, pqair, pslp , puice, pvice, ptsui,  &   ! inputs
       &                  putaui, pvtaui, pseni, pevpi, pssqi, pcd_dui             )   ! optional outputs
       !!---------------------------------------------------------------------
@@ -902,5 +974,5 @@
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pwndj   ! atmospheric wind at T-point [m/s]
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   ptair   ! atmospheric wind at T-point [m/s]
-      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   phumi   ! atmospheric wind at T-point [m/s]
+      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pqair   ! atmospheric wind at T-point [m/s]
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   puice   ! sea-ice velocity on I or C grid [m/s]
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pvice   ! "
@@ -915,9 +987,10 @@
       INTEGER  ::   ji, jj    ! dummy loop indices
       REAL(wp) ::   zootm_su                      ! sea-ice surface mean temperature
-      REAL(wp) ::   zztmp1, zztmp2                ! temporary arrays
-      REAL(wp), DIMENSION(jpi,jpj) ::   zcd_dui   ! transfer coefficient for momentum      (tau)
-      !!---------------------------------------------------------------------
-      !
-
+      REAL(wp) ::   zztmp1, zztmp2                ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpj) :: ztmp        ! temporary array
+      !!---------------------------------------------------------------------
+      !
+      ! LB: ptsui is in K !!!
+      !
       ! ------------------------------------------------------------ !
       !    Wind module relative to the moving ice ( U10m - U_ice )   !
@@ -925,23 +998,45 @@
       ! C-grid ice dynamics :   U & V-points (same as ocean)
       DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
-         wndm_ice(ji,jj) = SQRT( pwndi(ji,jj) * pwndi(ji,jj) + pwndj(ji,jj) * pwndj(ji,jj) )
+      wndm_ice(ji,jj) = SQRT( pwndi(ji,jj) * pwndi(ji,jj) + pwndj(ji,jj) * pwndj(ji,jj) )
       END_2D
       !
       ! Make ice-atm. drag dependent on ice concentration
-      IF    ( ln_Cd_L12 ) THEN   ! calculate new drag from Lupkes(2012) equations
-         CALL Cdn10_Lupkes2012( Cd_ice )
-         Ch_ice(:,:) = Cd_ice(:,:)       ! momentum and heat transfer coef. are considered identical
-         Ce_ice(:,:) = Cd_ice(:,:)
-      ELSEIF( ln_Cd_L15 ) THEN   ! calculate new drag from Lupkes(2015) equations
-         CALL Cdn10_Lupkes2015( ptsui, pslp, Cd_ice, Ch_ice )
-         Ce_ice(:,:) = Ch_ice(:,:)       ! sensible and latent heat transfer coef. are considered identical
-      ENDIF
-      
-      IF( iom_use('Cd_ice') ) CALL iom_put("Cd_ice", Cd_ice)
-      IF( iom_use('Ce_ice') ) CALL iom_put("Ce_ice", Ce_ice)
-      IF( iom_use('Ch_ice') ) CALL iom_put("Ch_ice", Ch_ice)
-      
-      ! local scalars ( place there for vector optimisation purposes)
-      zcd_dui(:,:) = wndm_ice(:,:) * Cd_ice(:,:)
+
+
+      SELECT CASE( nblk_ice )
+
+      CASE( np_ice_cst      )
+         ! Constant bulk transfer coefficients over sea-ice:
+         Cd_ice(:,:) = rn_Cd_i
+         Ch_ice(:,:) = rn_Ch_i
+         Ce_ice(:,:) = rn_Ce_i
+         ! no height adjustment, keeping zt values:
+         theta_zu_i(:,:) = ptair(:,:)
+         q_zu_i(:,:)     = pqair(:,:)
+
+      CASE( np_ice_an05 )  ! calculate new drag from Lupkes(2015) equations
+         ztmp(:,:) = q_sat( ptsui(:,:), pslp(:,:), l_ice=.TRUE. ) ! temporary array for SSQ
+         CALL turb_ice_an05( rn_zqt, rn_zu, ptsui, ptair, ztmp, pqair, wndm_ice,       &
+            &                      Cd_ice, Ch_ice, Ce_ice, theta_zu_i, q_zu_i )
+         !!
+      CASE( np_ice_lu12 )
+         ztmp(:,:) = q_sat( ptsui(:,:), pslp(:,:), l_ice=.TRUE. ) ! temporary array for SSQ
+         CALL turb_ice_lu12( rn_zqt, rn_zu, ptsui, ptair, ztmp, pqair, wndm_ice, fr_i, &
+            &                      Cd_ice, Ch_ice, Ce_ice, theta_zu_i, q_zu_i )
+         !!
+      CASE( np_ice_lg15 )  ! calculate new drag from Lupkes(2015) equations
+         ztmp(:,:) = q_sat( ptsui(:,:), pslp(:,:), l_ice=.TRUE. ) ! temporary array for SSQ
+         CALL turb_ice_lg15( rn_zqt, rn_zu, ptsui, ptair, ztmp, pqair, wndm_ice, fr_i, &
+            &                      Cd_ice, Ch_ice, Ce_ice, theta_zu_i, q_zu_i )
+         !!
+      END SELECT
+
+      IF( iom_use('Cd_ice').OR.iom_use('Ce_ice').OR.iom_use('Ch_ice').OR.iom_use('taum_ice').OR.iom_use('utau_ice').OR.iom_use('vtau_ice') ) &
+         & ztmp(:,:) = ( 1._wp - MAX(0._wp, SIGN( 1._wp, 1.E-6_wp - fr_i )) )*tmask(:,:,1) ! mask for presence of ice !
+
+      IF( iom_use('Cd_ice') ) CALL iom_put("Cd_ice", Cd_ice*ztmp)
+      IF( iom_use('Ce_ice') ) CALL iom_put("Ce_ice", Ce_ice*ztmp)
+      IF( iom_use('Ch_ice') ) CALL iom_put("Ch_ice", Ch_ice*ztmp)
+
 
       IF( ln_blk ) THEN
@@ -950,11 +1045,20 @@
          ! ---------------------------------------------------- !
          ! supress moving ice in wind stress computation as we don't know how to do it properly...
-         DO_2D( 0, 1, 0, 1 )    ! at T point 
-            putaui(ji,jj) = rhoa(ji,jj) * zcd_dui(ji,jj) * pwndi(ji,jj)
-            pvtaui(ji,jj) = rhoa(ji,jj) * zcd_dui(ji,jj) * pwndj(ji,jj)
+         DO_2D( 0, 1, 0, 1 )    ! at T point
+            zztmp1        = rhoa(ji,jj) * Cd_ice(ji,jj) * wndm_ice(ji,jj)
+            putaui(ji,jj) =  zztmp1 * pwndi(ji,jj)
+            pvtaui(ji,jj) =  zztmp1 * pwndj(ji,jj)
          END_2D
+
+         !#LB: saving the module, and x-y components, of the ai wind-stress at T-points: NOT weighted by the ice concentration !!!
+         IF(iom_use('taum_ice')) CALL iom_put('taum_ice', SQRT( putaui*putaui + pvtaui*pvtaui )*ztmp )
+         !#LB: These 2 lines below mostly here for 'STATION_ASF' test-case, otherwize "utau_oi" (U-grid) and vtau_oi" (V-grid) does the job in: [ICE/icedyn_rhg_evp.F90])
+         IF(iom_use('utau_ice')) CALL iom_put("utau_ice", putaui*ztmp)  ! utau at T-points!
+         IF(iom_use('vtau_ice')) CALL iom_put("vtau_ice", pvtaui*ztmp)  ! vtau at T-points!
+
          !
          DO_2D( 0, 0, 0, 0 )    ! U & V-points (same as ocean).
-            ! take care of the land-sea mask to avoid "pollution" of coastal stress. p[uv]taui used in frazil and  rheology 
+            !#LB: QUESTION?? so SI3 expects wind stress vector to be provided at U & V points? Not at T-points ?
+            ! take care of the land-sea mask to avoid "pollution" of coastal stress. p[uv]taui used in frazil and  rheology
             zztmp1 = 0.5_wp * ( 2. - umask(ji,jj,1) ) * MAX( tmask(ji,jj,1),tmask(ji+1,jj  ,1) )
             zztmp2 = 0.5_wp * ( 2. - vmask(ji,jj,1) ) * MAX( tmask(ji,jj,1),tmask(ji  ,jj+1,1) )
@@ -967,14 +1071,13 @@
             &                               , tab2d_2=pvtaui  , clinfo2='          pvtaui : ' )
       ELSE ! ln_abl
-         zztmp1 = 11637800.0_wp
-         zztmp2 =    -5897.8_wp
          DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
-            pcd_dui(ji,jj) = zcd_dui (ji,jj)
-            pseni  (ji,jj) = wndm_ice(ji,jj) * Ch_ice(ji,jj)
-            pevpi  (ji,jj) = wndm_ice(ji,jj) * Ce_ice(ji,jj)
-            zootm_su       = zztmp2 / ptsui(ji,jj)   ! ptsui is in K (it can't be zero ??)
-            pssqi  (ji,jj) = zztmp1 * EXP( zootm_su ) / rhoa(ji,jj)
+         pcd_dui(ji,jj) = wndm_ice(ji,jj) * Cd_ice(ji,jj)
+         pseni  (ji,jj) = wndm_ice(ji,jj) * Ch_ice(ji,jj)
+         pevpi  (ji,jj) = wndm_ice(ji,jj) * Ce_ice(ji,jj)
          END_2D
-      ENDIF
+         !#LB:
+         pssqi(:,:) = q_sat( ptsui(:,:), pslp(:,:), l_ice=.TRUE. ) ; ! more accurate way to obtain ssq !
+         !#LB.
+      ENDIF !IF( ln_blk )
       !
       IF(sn_cfctl%l_prtctl)  CALL prt_ctl(tab2d_1=wndm_ice  , clinfo1=' blk_ice: wndm_ice : ')
@@ -983,5 +1086,5 @@
 
 
-   SUBROUTINE blk_ice_2( ptsu, phs, phi, palb, ptair, phumi, pslp, pqlw, pprec, psnow  )
+   SUBROUTINE blk_ice_2( ptsu, phs, phi, palb, ptair, pqair, pslp, pdqlw, pprec, psnow  )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE blk_ice_2  ***
@@ -999,16 +1102,15 @@
       REAL(wp), DIMENSION(:,:,:), INTENT(in)  ::   phi    ! ice thickness
       REAL(wp), DIMENSION(:,:,:), INTENT(in)  ::   palb   ! ice albedo (all skies)
-      REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   ptair
-      REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   phumi
+      REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   ptair  ! potential temperature of air #LB: okay ???
+      REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   pqair  ! specific humidity of air
       REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   pslp
-      REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   pqlw
+      REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   pdqlw
       REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   pprec
       REAL(wp), DIMENSION(:,:  ), INTENT(in)  ::   psnow
       !!
       INTEGER  ::   ji, jj, jl               ! dummy loop indices
-      REAL(wp) ::   zst3                     ! local variable
+      REAL(wp) ::   zst, zst3, zsq           ! local variable
       REAL(wp) ::   zcoef_dqlw, zcoef_dqla   !   -      -
-      REAL(wp) ::   zztmp, zztmp2, z1_rLsub  !   -      -
-      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z1_st         ! inverse of surface temperature
+      REAL(wp) ::   zztmp, zzblk, zztmp1, z1_rLsub   !   -      -
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z_qlw         ! long wave heat flux over ice
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z_qsb         ! sensible  heat flux over ice
@@ -1016,42 +1118,33 @@
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z_dqsb        ! sensible  heat sensitivity over ice
       REAL(wp), DIMENSION(jpi,jpj)     ::   zevap, zsnw   ! evaporation and snw distribution after wind blowing (SI3)
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zqair         ! specific humidity of air at z=rn_zqt [kg/kg] !LB
       REAL(wp), DIMENSION(jpi,jpj)     ::   ztmp, ztmp2
       REAL(wp), DIMENSION(jpi,jpj)     ::   ztri
       !!---------------------------------------------------------------------
       !
-      zcoef_dqlw = 4._wp * 0.95_wp * stefan             ! local scalars
-      zcoef_dqla = -rLsub * 11637800._wp * (-5897.8_wp) !LB: BAD!
-      !
-      SELECT CASE( nhumi )
-      CASE( np_humi_sph )
-         zqair(:,:) =  phumi(:,:)      ! what we read in file is already a spec. humidity!
-      CASE( np_humi_dpt )
-         zqair(:,:) = q_sat( phumi(:,:), pslp )
-      CASE( np_humi_rlh )
-         zqair(:,:) = q_air_rh( 0.01_wp*phumi(:,:), ptair(:,:), pslp(:,:) ) !LB: 0.01 => RH is % percent in file
-      END SELECT
-      !
+      zcoef_dqlw = 4._wp * emiss_i * stefan             ! local scalars
+      !
+
       zztmp = 1. / ( 1. - albo )
-      WHERE( ptsu(:,:,:) /= 0._wp )
-         z1_st(:,:,:) = 1._wp / ptsu(:,:,:)
-      ELSEWHERE
-         z1_st(:,:,:) = 0._wp
-      END WHERE
+      dqla_ice(:,:,:) = 0._wp
+
       !                                     ! ========================== !
       DO jl = 1, jpl                        !  Loop over ice categories  !
          !                                  ! ========================== !
-         DO jj = 1 , jpj
-            DO ji = 1, jpi
+         DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
+
+               zst = ptsu(ji,jj,jl)                           ! surface temperature of sea-ice [K]
+               zsq = q_sat( zst, pslp(ji,jj), l_ice=.TRUE. )  ! surface saturation specific humidity when ice present
+
                ! ----------------------------!
                !      I   Radiative FLUXES   !
                ! ----------------------------!
-               zst3 = ptsu(ji,jj,jl) * ptsu(ji,jj,jl) * ptsu(ji,jj,jl)
                ! Short Wave (sw)
                qsr_ice(ji,jj,jl) = zztmp * ( 1. - palb(ji,jj,jl) ) * qsr(ji,jj)
+
                ! Long  Wave (lw)
-               z_qlw(ji,jj,jl) = 0.95 * ( pqlw(ji,jj) - stefan * ptsu(ji,jj,jl) * zst3 ) * tmask(ji,jj,1)
+               zst3 = zst * zst * zst
+               z_qlw(ji,jj,jl)   = emiss_i * ( pdqlw(ji,jj) - stefan * zst * zst3 ) * tmask(ji,jj,1)
                ! lw sensitivity
-               z_dqlw(ji,jj,jl) = zcoef_dqlw * zst3
+               z_dqlw(ji,jj,jl)  = zcoef_dqlw * zst3
 
                ! ----------------------------!
@@ -1060,20 +1153,22 @@
 
                ! ... turbulent heat fluxes with Ch_ice recalculated in blk_ice_1
+
+               ! Common term in bulk F. equations...
+               zzblk = rhoa(ji,jj) * wndm_ice(ji,jj)
+
                ! Sensible Heat
-               z_qsb(ji,jj,jl) = rhoa(ji,jj) * rCp_air * Ch_ice(ji,jj) * wndm_ice(ji,jj) * (ptsu(ji,jj,jl) - ptair(ji,jj))
+               zztmp1 = zzblk * rCp_air * Ch_ice(ji,jj)
+               z_qsb (ji,jj,jl) = zztmp1 * (zst - theta_zu_i(ji,jj))
+               z_dqsb(ji,jj,jl) = zztmp1                        ! ==> Qsens sensitivity (Dqsb_ice/Dtn_ice)
+
                ! Latent Heat
-               zztmp2 = EXP( -5897.8 * z1_st(ji,jj,jl) )
-               qla_ice(ji,jj,jl) = rn_efac * MAX( 0.e0, rhoa(ji,jj) * rLsub  * Ce_ice(ji,jj) * wndm_ice(ji,jj) *  &
-                  &                ( 11637800. * zztmp2 / rhoa(ji,jj) - zqair(ji,jj) ) )
-               ! Latent heat sensitivity for ice (Dqla/Dt)
-               IF( qla_ice(ji,jj,jl) > 0._wp ) THEN
-                  dqla_ice(ji,jj,jl) = rn_efac * zcoef_dqla * Ce_ice(ji,jj) * wndm_ice(ji,jj) *  &
-                     &                 z1_st(ji,jj,jl) * z1_st(ji,jj,jl) * zztmp2
-               ELSE
-                  dqla_ice(ji,jj,jl) = 0._wp
-               ENDIF
-
-               ! Sensible heat sensitivity (Dqsb_ice/Dtn_ice)
-               z_dqsb(ji,jj,jl) = rhoa(ji,jj) * rCp_air * Ch_ice(ji,jj) * wndm_ice(ji,jj)
+               zztmp1 = zzblk * rLsub * Ce_ice(ji,jj)
+               qla_ice(ji,jj,jl) = MAX( zztmp1 * (zsq - q_zu_i(ji,jj)) , 0._wp )   ! #LB: only sublimation (and not condensation) ???
+               IF(qla_ice(ji,jj,jl)>0._wp) dqla_ice(ji,jj,jl) = zztmp1*dq_sat_dt_ice(zst, pslp(ji,jj)) ! ==> Qlat sensitivity  (dQlat/dT)
+               !                                                                                       !#LB: dq_sat_dt_ice() in "sbc_phy.F90"
+               !#LB: without this unjustified "condensation sensure":
+               !qla_ice( ji,jj,jl) = zztmp1 * (zsq - q_zu_i(ji,jj))
+               !dqla_ice(ji,jj,jl) = zztmp1 * dq_sat_dt_ice(zst, pslp(ji,jj)) ! ==> Qlat sensitivity  (dQlat/dT)
+
 
                ! ----------------------------!
@@ -1083,8 +1178,7 @@
                qns_ice (ji,jj,jl) =     z_qlw (ji,jj,jl) - z_qsb (ji,jj,jl) - qla_ice (ji,jj,jl)
                ! Total non solar heat flux sensitivity for ice
-               dqns_ice(ji,jj,jl) = - ( z_dqlw(ji,jj,jl) + z_dqsb(ji,jj,jl) + dqla_ice(ji,jj,jl) )
-            END DO
-            !
-         END DO
+               dqns_ice(ji,jj,jl) = - ( z_dqlw(ji,jj,jl) + z_dqsb(ji,jj,jl) + dqla_ice(ji,jj,jl) ) !#LB: correct signs ????
+
+         END_2D
          !
       END DO
@@ -1138,10 +1232,10 @@
          ztri(:,:) = 0.18 * ( 1.0 - cloud_fra(:,:) ) + 0.35 * cloud_fra(:,:)  ! surface transmission when hi>10cm
          DO jl = 1, jpl
-            WHERE    ( phs(:,:,jl) <= 0._wp .AND. phi(:,:,jl) <  0.1_wp )     ! linear decrease from hi=0 to 10cm  
+            WHERE    ( phs(:,:,jl) <= 0._wp .AND. phi(:,:,jl) <  0.1_wp )     ! linear decrease from hi=0 to 10cm
                qtr_ice_top(:,:,jl) = qsr_ice(:,:,jl) * ( ztri(:,:) + ( 1._wp - ztri(:,:) ) * ( 1._wp - phi(:,:,jl) * 10._wp ) )
             ELSEWHERE( phs(:,:,jl) <= 0._wp .AND. phi(:,:,jl) >= 0.1_wp )     ! constant (ztri) when hi>10cm
                qtr_ice_top(:,:,jl) = qsr_ice(:,:,jl) * ztri(:,:)
             ELSEWHERE                                                         ! zero when hs>0
-               qtr_ice_top(:,:,jl) = 0._wp 
+               qtr_ice_top(:,:,jl) = 0._wp
             END WHERE
          ENDDO
